module OrientDb
  class CollectionRepository < Base
    include OrientDb::Methods::EdgeMethods

    # Example:
    #   list = repository.for(:collections).all
    #   list.each do |collection|
    #     collection_object.inspect <LearningObject model>
    #   end
    def all
      hash = connection.query "SELECT FROM Collection"
      collections = build_collections(hash)
    end

    # Usage:
    #   collection = repository.for(:collections).get_by_dspace_id 123
    #
    def find(id)
      result = connection.query "SELECT FROM #{id}"
      build_collection result.first
    end

    def create(name, url)
      connection.command sprintf("INSERT INTO Collection (name) VALUES ('%s')", name)
    end

    # Usage:
    #   repository.for(:collections).destroy collection
    #
    def destroy(collection)
      connection.command sprintf("DELETE VERTEX %s", collection.id)
    end

    private

    def build_collection(args={})
      return Collection.new(
        :id => args["@rid"],
        :name => args["name"]
      )
    end

    def build_collections(hash=[])
      collections = []
      hash.each do |h|
        collections << build_collection(h)
      end
      return collections
    end

  end
end
