namespace :mainPage do
  desc "Generate the MainPage"
  task :highlights => :environment do
    repository = Portalmec::Application.repository
    puts 'Generate the main page subject highlights'
    general_highlights = Array.new
    subjects = repository.for(:subject).find_all
    subjects.each do |subject|
      # select all the learning objects about that subject
      objects = repository.for(:subject).get_objects(subject['@rid'])
      # transform the objects to RankingItem
      objects = objects.collect do |object|
        downloads = 0
        object = repository.for(:learning_object).find(object['@rid'])
        Ranking::Item.new(object.id,object.views.first["COUNT"],downloads,object.likes.first["COUNT"])
      end
      # rank them
      rater = Ranking::Rater.new(Ranking::Strategies::BasicRater.new(0,1,100))
      objects = rater.sortByRate(objects)
      # select the five first objects to the general highlight
      (general_highlights << objects.take(5)).flatten!

      # add the object to the subject highlight
      puts subject['name']
      repository.for(:subject).update(subject['@rid'],'set','highlights','[]')
      objects.each do |object|
        repository.for(:subject).update(subject['@rid'],'add','highlights',object.name)
      end
    end
    puts 'Generating the main page highlights'
    mainPage = repository.for(:mainPage).find_all.first
    rid = mainPage['@rid']
    repository.for(:mainPage).update(rid,'set','highlights','[]')
    general_highlights.each do |general_highlight|
      repository.for(:mainPage).update(rid,'add','highlights',general_highlight.name)
    end
  end
end
