require 'test_helper'
require 'test_model_repository'

class Repository::RepositoryTest < ActiveSupport::TestCase

  def setup
    @repository = Repository::Repository.new
    @repository.register :test_model, TestModelRepository.new
  end

  test 'can register a repository' do
    assert_count 1, @repository.repositories
  end

  test 'can unregister a repository' do
    @repository.unregister :test_model
    assert_count 0, @repository.repositories
  end

  test 'select a repository by type' do
    assert @repository.for(:test_model).working?
  end

end